/* $Id: linklist.h,v 1.3 1998/02/11 04:37:35 ashaikh Exp $ */

/*
*   Description:
*
*	Header file for a simple linked list implementation
*
*/

#ifndef _linklist_h_
#define _linklist_h_


typedef struct linklist_t {
  int			numelements;
  struct listnode_t	*head,*tail;
} linklist_t;

/********************************************************************************/

linklist_t
*listInit (void);

int
listInsert (linklist_t *, void *);

int
listAttach (linklist_t *, void *);

int
listPush (linklist_t *, void *);

int
listPop (linklist_t *, void **);     

int
listReverse (linklist_t *);

void
listPrint (linklist_t *);

int
listSize (linklist_t *);

int
listEmpty (linklist_t *);

int
listGetElement(linklist_t *, int, void **);

int
listGetFirstElement (linklist_t *, void **);

void *
listGetTop (linklist_t *);

int
listDestroy (linklist_t *);





#endif
