/* $Id: priorityQ.h,v 1.4 1998/01/05 20:28:01 ashaikh Exp $ */
/*
*   Description:
*
*	Header file for priority queue data structure operations.
*
*/

#ifndef _priorityQ_h_
#define _priorityQ_h_


typedef struct _pqelement_t {		/* type of queue elements */
  int	    id;
  double    key;
  void	    *element;
} pqelement_t;

typedef struct _pq_t {
  int		numitems;
  int		qsize;
  pqelement_t	**Q;
} pq_t;

/*******************************************************************************/

pq_t
*pqInit (int);

int
pqDestroy (pq_t *);

int pqAddItem (pq_t *, pqelement_t * );

int pqRemoveItem (pq_t *, pqelement_t **);

double pqCheckKey (pq_t *);

int pqChangeVal (pq_t *, int, double);

int pqIsQEmpty (pq_t *);
     
void pqPrintQ (pq_t *);

#endif

