/* $Id: rsevents.h,v 1.3 1999/06/11 21:32:59 ashaikh Exp $ */

#ifndef _rsevents_h_
#define _rsevents_h_


#include "rsdefs.h"
#include <stack.h>

/********************************************************************************/

/*
class Event {
public:
  Event (double t, eventtype_t evtype, void *ptr);
  Event();
  // default destructor -- just free Event
  ~Event();
  
  void operator=(Event &source);
  
  double	time;
  eventtype_t	type;
  void		*info;
};
*/

/********************************************************************************/

typedef enum {STARTCALL, ENDCALL, RECOMP} eventtype_t;

typedef struct _event_t {
  double	time;
  eventtype_t	type;
  void		*info;
} event_t;

typedef event_t*    eventptr_t;

// compare function for events 
class eventptrLess
{
public:
  bool operator () (const eventptr_t&, const eventptr_t& y);
};

bool eventptrLess::operator() (const eventptr_t& ev1, const eventptr_t& ev2)
{
  if (ev1->time > ev2->time)
    return (true);
  else return (false);
}
/********************************************************************************/

#ifdef USE_DEQUE
typedef priority_queue<eventptr_t, deque<eventptr_t>, eventptrLess> eventQ;
#else
typedef priority_queue<eventptr_t, vector<eventptr_t>, eventptrLess> eventQ;
#endif

/*  the template defs below work with libg++ from gcc version 2.7
#ifdef USE_DEQUE
typedef priority_queue<deque<eventptr_t>, eventptrLess> eventQ;
#else
typedef priority_queue<vector<eventptr_t>, eventptrLess> eventQ;
#endif
*/



#endif
