/* $Id: rsroute.h,v 1.7 1999/06/02 20:54:53 ashaikh Exp $ */

#ifndef _rsroute_h_
#define _rsroute_h_

#include "rsroutedefs.h"
#include "rsdefs.h"

/* Routing related types and definitions */

#define	    INF			(INT_MAX-1)
#define	    MAX_COST_LEVELS	(INT_MAX-1)

#define	    ROUTING_SUCCESS_NR	27  /* routing success with only extraction */
#define	    ROUTING_SUCCESS_R	28  /* routing success with a recomputation */
#define	    ROUTING_FAILURE	29  /* routing failure always recomputes */
#define	    ROUTE_CALC_SUCCESS	30  /* overall routing calc success */
#define	    ROUTE_CALC_FAIL	31  /* source is disconnected */
#define	    ROUTE_CALC_DISCONN	32  /* some nodes are disconnected */
#define	    ROUTE_EXT_SUCCESS	33  /* route extraction success */
#define	    ROUTE_EXT_FAIL	34  /* no feasible route or dest is disconn */
#define	    ROUTE_EXT_FAIL_LEN	35  /* extracted route is too long */

/********************************************************************************/
int
initRouting (routealg_t, topology_t *);
int
cleanupRouting (topology_t *);

int
setRoutePolicy (topology_t *, void *);

int
routeCall (call_t *, double, int *);
/* Added call_t as an argument to reComputeRoute
 * To help in HSF as allroutes is in the call!!!
 * Ganga - 03/12/2000
 */

int
reComputeRoute (call_t *, int, double, double, topology_t *, int *);
int
extractRoute (call_t *, double, int *);
int
getLinks (int *, int,  link_t ***, topology_t *);


double
getLinkCost (link_t *, distfunction_t, staleness_t, topology_t *);
int
linkExists (int, int, double, prunepolicy_t, staleness_t, topology_t *);
double
getLinkAvailBandwidth (link_t *, staleness_t);

void
printRoutingAlgorithm (topology_t *);
void
printRoutingPolicy (void);
void
printAltPolicy (topology_t *);
void
printStaleness (void);
void
printPrunePolicy (topology_t *);
void
printDistFunction (topology_t *);

double
getLastRouteCompTime (int, topology_t *);
int
getNumRouteComps (int, topology_t *);
int
resetRouteComps (int, topology_t *);

#endif
