/* $Id: spt.h,v 3.9 1999/06/02 21:14:07 ashaikh Exp $ */

#ifndef _spt_h_
#define _spt_h_

#include "rsdefs.h"
#include "sptgeneric.h"
#include "rsroute.h"
#include "general.h"


typedef struct {
  prunepolicy_t	    prunep;	    /* policy used for pruning links */
  distfunction_t    distfunc;	    /* shortest path calc parameter */
  alternate_t	    altpolicy;	    /* how alternate routing should work */
  multipolicy_t	    multipolicy;    /* how to use multiple routes in extraction */
  uniqpolicy_t	    uniqpolicy;	    /* how to pick uniquely among multiple routes */
} sptpolicy_t;

/********************************************************************************/
int
sptExec (spt_t *, int, double, double, prunepolicy_t,
	 distfunction_t, staleness_t, int *);

int
sptExtractSinglePath (spt_t *, call_t *, boolean, int **, int *);
int
sptExtractMultiPath (spt_t *, call_t *, alternate_t, boolean, int **, int *);
int
sptExtractUniqPath (spt_t *, call_t *, int, int, uniqpolicy_t,
		    boolean, int **, int *);

void
sptPrintUniqPath (spt_t *, int, uniqpolicy_t);
void
sptPrintFirstPath (spt_t *, int);




#endif
