/*
 * $Id: opt-parse.h,v 1.7 1998/06/04 19:55:41 ashaikh Exp $
 */

#ifndef _opt_parse_h_
#define _opt_parse_h_

#include "general.h"

#define _OPT_PARSE_H
#define MAX_GEN_TABLE_SIZE 8
#define GEN_STR_TABLE_WIDTH 24
/* width of generic search tables */
#define MAX_OPTIONS 128
typedef enum {
  boolean_op, float_op, double_op, long_op, funcall, int_op, string_op, generic_op
} option_type;

typedef struct option_struct{
  int index;
  char s_name[64], l_name[64];
  char des[255];
  option_type type;
  void (*func)(void *to, void *from);
  void *var;
  void *validp;
  void *generic_offset;
} op_struct;

void parse_conf_file (char *filename);
void usage (void);
void insert_option(char *s0, char *s1,
		   option_type t, void *var,
		   char *d,
		   void * validp,
		   void * offset);
int submatch (char *a, char *b);
int strmatch (char *target, char *s, char *l);
boolean toggle (boolean var);
void boolean_assign (boolean *var, boolean *val);
void float_assign (float *var, char *val);
void double_assign (double *var, char *val);
void int_assign (int *var, char *val);
void string_assign (char *var, char *val);
void name_match (int num_options, char table[][GEN_STR_TABLE_WIDTH],
		 char *target, void *var);
boolean match (int *argc, int *index, char **argv);
void parse_command_line (int argc, char**argv);
void option_print(int i, char *o, char *v);
void dump_state ();


#endif
