/* $Id: rsstatlist.h,v 1.1 1999/01/08 05:37:42 ashaikh Exp $ */

#ifndef _rsstatlist_h_
#define _rsstatlist_h_

#include "stat.h"

typedef struct {
  /* global call stats */
  int terminatedcalls;
  int sigfailures;
  int routefailures;
  simpleratio_t callblk;
  double utilizationsum;
  double totalutilsum;
  int sigattempts;
  int extractfailures;
  int rerouteattempts;
  simpleratio_t rcompspersucccall;
  simpleratio_t rcompsperfailcall;
  simpleratio_t sigattpersucccall;
  simpleratio_t sigattperfailcall;
  simpleratio_t routecachehits;
  simpleratio_t *perhcrcomps;
  simpleratio_t *perhcsigatt;
  simpleratio_t *callsperhop;
  simpleratio_t rcompinterval;
  simpleratio_t extractpersucccall;
  simpleratio_t extractperfailcall;
  simpleratio_t timesincecompfail;
  simpleratio_t timesincecompsucc;
  simpleratio_t timesincelinkupdfail;
  simpleratio_t timesincelinkupdsucc;
  /* update stats */
  simpleratio_t updinterval;
  int rlinkupdates;
  int tlinkupdates;
  int extraupdates;
  int deferredupdates;
  /* traffic stats */
  simpleratio_t residual;
  double blockedbw;
  double requestedbw;
  double maxsuccduration;
  double maxdurationtime;
  simpleratio_t reqbwstat;
  simpleratio_t holdtimestat;
  simpleratio_t arrivalratestat;
  /* route stats */
  simpleratio_t *perhcblk;
  double blockedhcbw;
  double requestedhcbw;
  double blockedhc;
  double requestedhc;
  int sumhops;
  int summinhops;
  int sumhopdiff;
  int maxhopdiff;
  int longroutes;
} rsstat_t;

#endif
