/* $Id: rstrace.h,v 2.6 1998/08/13 04:54:17 ashaikh Exp $ */

#ifndef _rstrace_h_
#define _rstrace_h_

#include <stdio.h>

/* trace levels */
#define	    TRACE_ALWAYS	(0)
#define	    TRACE_ERRORS	(1)
#define	    TRACE_SOFT_ERRORS	(2)
#define	    TRACE_GROSS_EVENTS	(3)
#define	    TRACE_EVENTS	(4)
#define	    TRACE_MORE_EVENTS	(5)
#define	    TRACE_DETAILS	(6)
#define	    TRACE_ALL		(7)

#ifndef RS_TRACE_LEVEL
#define	    RS_TRACE_LEVEL	(TRACE_ERRORS)  /* default trace level */
#endif

/* trace macros */

#if RS_TRACE_LEVEL >= TRACE_ALWAYS
#define RS_PRINT_ALWAYS(string)   \
    fprintf (stderr, string);
#else
#define RS_PRINT_ALWAYS(string)
#endif

#if RS_TRACE_LEVEL >= TRACE_ERRORS    
#define RS_PRINT_ERROR(string)   \
    fprintf (stderr, string);
#else
#define RS_PRINT_ERROR(string)
#endif

#if RS_TRACE_LEVEL >= TRACE_ERRORS    
#define RS_PRINT_ERROR1(string,param1)   \
    fprintf (stderr, string, param1);
#else
#define RS_PRINT_ERROR1(string,param1)
#endif

#if RS_TRACE_LEVEL >= TRACE_SOFT_ERRORS    
#define RS_PRINT_SOFT_ERROR(string)   \
    fprintf (stderr, string);
#else
#define RS_PRINT_SOFT_ERROR(string)
#endif

#if RS_TRACE_LEVEL >= TRACE_SOFT_ERRORS    
#define RS_PRINT_SOFT_ERROR1(string,param1)   \
    fprintf (stderr, string, param1);
#else
#define RS_PRINT_SOFT_ERROR1(string,param1)
#endif

#if RS_TRACE_LEVEL >= TRACE_GROSS_EVENTS
#define RS_PRINT_GROSS_EVENT(string)	\
    printf (string);
#else
#define RS_PRINT_GROSS_EVENT(string)
#endif

#if RS_TRACE_LEVEL >= TRACE_GROSS_EVENTS
#define RS_PRINT_GROSS_EVENT1(string,param1)	\
    printf (string, param1);
#else
#define RS_PRINT_GROSS_EVENT1(string,param1)
#endif

#if RS_TRACE_LEVEL >= TRACE_GROSS_EVENTS
#define RS_PRINT_GROSS_EVENT2(string,param1,param2)	\
    printf (string, param1, param2);
#else
#define RS_PRINT_GROSS_EVENT2(string,param1,param2)
#endif

#if RS_TRACE_LEVEL >= TRACE_EVENTS
#define RS_PRINT_EVENT(string)	\
    printf (string);
#else
#define RS_PRINT_EVENT(string)
#endif

#if RS_TRACE_LEVEL >= TRACE_EVENTS
#define RS_PRINT_EVENT1(string,param1)	\
    printf (string, param1);
#else
#define RS_PRINT_EVENT1(string,param1)
#endif

#if RS_TRACE_LEVEL >= TRACE_EVENTS
#define RS_PRINT_EVENT2(string,param1,param2)	\
    printf (string, param1, param2);
#else
#define RS_PRINT_EVENT2(string,param1,param2)
#endif

#if RS_TRACE_LEVEL >= TRACE_EVENTS
#define RS_PRINT_EVENT3(string,param1,param2,param3)	\
    printf (string, param1, param2, param3);
#else
#define RS_PRINT_EVENT3(string,param1,param2,param3)
#endif

#if RS_TRACE_LEVEL >= TRACE_DETAILS
#define RS_PRINT_DETAIL(string)	\
    printf (string);
#else
#define RS_PRINT_DETAIL(string)
#endif

#if RS_TRACE_LEVEL >= TRACE_MORE_EVENTS
#define RS_PRINT_MORE_EVENT(string)	\
    printf (string);
#else
#define RS_PRINT_MORE_EVENT(string)
#endif

#endif /* #ifndef _rstrace_h_ */
