/* $Id: stat.h,v 1.2 1998/12/07 19:59:33 ashaikh Exp $ */

#ifndef _stat_h_
#define _stat_h_

typedef struct {
  double    lb;
  double    ub;
  double    level;
} confint_t;


typedef struct simpleratio_t {
  double    numersum;
  double    numersumsq;
  int	    denomsum;
  double    currentrate;
  double    currentvar;
  double    min;
  double    max;
  confint_t conf;
} simpleratio_t;

typedef struct {
  double    numersum;
  double    totaldenom;
  double    proportion;  
  double    variance;
  confint_t conf;
} proportionstat_t;

int
initSimpleRatioStat (simpleratio_t *, double);
int
copySimpleRatioStat (simpleratio_t *, simpleratio_t *);
int
updateSimpleRatioStat (double, simpleratio_t *);
int
checkSimpleRatioStat (simpleratio_t *, double);
void
dumpSimpleRatioStat (simpleratio_t *);

int
initProportionStat (proportionstat_t *, double);
int
updateProportionStat (double, double, proportionstat_t *);
int
checkProportionStat (proportionstat_t *, double);
void
dumpProportionStat (proportionstat_t *);




#endif
