#!/bin/perl
#$Id: rsextract.pl,v 1.1 1997/07/09 22:34:04 shaikh Exp shaikh $
#$Source: /home/shaikh/routesim/data/periodsweep/RCS/rsextract.pl,v $
#
# A. Shaikh
#
# This script extracts data from results files generated by routesim.
# Basic operation is to make one pass through the file and use regular expressions
# to identify lines containing the desired data and placing it in it respective
# arrays.  Calculations are made on the arrays to obtain the desired metrics.
#
#
# some default filenames
require "/opt/users/ashaikh/Research/routesim/scripts/rsstrings.pm";
use Cwd ;

$input_file = "rs.out";
$conf_int_cmd = "confInterval";
$conf_level = 95;

# need some variables and arrays for algorithms


@bwvals = (.03);

@periods = (5, 10, 20, 30, 40, 60, 70, 80, 90, 100, 120, 130, 150, 170, 180);

%values = ();

$topdir = cwd();

##########################################################################################

&pickFile;
&writeValues;

##########################################################################################
# Find desired input lines and store numbers in their respective arrays

sub pickFile
{
    local ($a, $per, $infile, $bw, $match, $str, $len, $subdir);

    foreach $per (@periods) {
	foreach $bw (@bwvals) {
	    $infile = "rs-pd_$per-bw_$bw";
	    if (-e $infile) {
		open (RESULTS, "<$infile") || die "Could not open $infile for reading\n";
		while (<RESULTS>) {
		    chop;
		    if (/^\s*([0-9A-Za-z-\.\s\(\)]+):\s*([+-]*[0-9]*\.*[0-9]*)/) {	#find string
			$match = $1;
			$val = $2;
		      ITERATE: foreach $str (keys %matchstring) {
			  if ($matchstring{$str} ne $match) {
			      next;
			  }
			  else {
			      $values{$str}->{$bw}->{$per} = $val;
			      last ITERATE;
			  }
		      }
		    }
		}

	    }
	    close RESULTS;	    
	}
    }
}

##########################################################################################
sub writeValues
{
    local ($per, $len, $bw, $metric, $outsuffix, $outfile, $outdir, $subdir, $outsubdir);

    $outdir = "datafiles";
    $outsuffix = ".dat";
    # check for datafiles subdirectory
    if (! -d $outdir || ! -e $outdir) {
	die "Please create ./$outdir directory in $subdir!\n";
    }    
    # make subdirectories for each metric
    foreach $metric (keys %matchstring) {
	$outsubdir = $metric;
	if (-e "./$outdir/$outsubdir") {
	    die "Please cleanup ./$outdir directory in $subdir\n";
	}
	system ("mkdir $outdir/$outsubdir");	
    }
    foreach $bw (@bwvals) {
	foreach $metric (keys %matchstring) {
	    $outsubdir = $metric;
	    $outfile = "./$outdir/$outsubdir/" . "rs-bw_$bw-$metric" . $outsuffix;	    
	    if (-e $outfile) {
		die "$outfile already exists ... exiting\n";
	    }
	    open (OUTPUT, ">$outfile") || die "Could not open $outfile for writing\n";	    
	    foreach $per (@periods) {
		print OUTPUT "$per $values{$metric}->{$bw}->{$per}\n";
	    }
	    close OUTPUT;
	}
    }
}



