#include "usercdf.h"
#include <stdio.h>
#include <stdlib.h>

/*
 * Description:
 *
 * A simple program that runs through a cdf and computes the average residual
 * value, after splitting the distribution at different points.
 *
 */



#define CDFFILE "cdf.dat"

int
main (void)
{
  cdf_t		*cdf, *lower, *upper;
  int		flowtrig;
  double	u;
  int		pos;
  double	loavg, hiavg;

  
  if (readCDFFile (&cdf, CDFFILE)) {
    fprintf (stderr, "readCDFFile failed\n");
    exit (1);
  }

  for (flowtrig = 0; flowtrig <= 600; flowtrig += 10) {
    for (pos = 0; pos < cdf->numvalues - 1; pos++) {
      if (cdf->values[pos].x > flowtrig)
	break;
    }
    u = cdf->values[pos].u;	
    splitCDF (cdf, u, &lower, &upper);
    loavg = getCDFAvg (lower);
    hiavg = getCDFAvg (upper);
    destroyCDF (lower);
    destroyCDF (upper);
    printf ("%d\t%f\t%f\n", flowtrig, (1.0-u), hiavg);    
  }

}
    
      
	
  
