/* $Id: bfalg.h,v 1.6 1999/01/29 04:28:20 ashaikh Exp $ */


#ifndef _bfalg_h_
#define _bfalg_h_

#include "rsdefs.h"
#include "topology.h"

typedef struct {
  int		    parent;
  double	    bw;
} bfentry_t;

typedef struct {
  int		source;
  topology_t 	*network;
  int		valid;
  bfentry_t	**tt;
  int		hoplimit;
  int		extrahops;
  double	comptime;	/* time this table was computed */
  int		computations;   /* number of times this table was recomputed */
} bftab_t;	/* bellman-ford topology table */

/********************************************************************************/

int
bfInit (bftab_t **, int, int, int, topology_t *);
int
bfDestroy (bftab_t *);
int
bfReset (bftab_t *);

int
bfExec (bftab_t *, double);

int
bfExtractPath (bftab_t *, call_t *, int **, int *);
int
bfGetPathLen (bftab_t *, int, double);

void
printBFTable (bftab_t *);
void
bfPrintPath (bftab_t *, int, double);


#endif
