/* $Id: clinklist.h,v 1.2 1998/02/11 04:36:51 ashaikh Exp $ */

/*
*   Description:
*
*	Header file for a simple circular linked list implementation
*
*/

#ifndef _clinklist_h_
#define _clinklist_h_


typedef struct clinklist_t {
  int			numelements;
  struct clistnode_t	*last;
} clinklist_t;

typedef struct clistnode_t {
  void			*element;
  struct clistnode_t	*next;
} clistnode_t;

typedef struct {
  clinklist_t	    *list;
  clistnode_t	    *current;
} clistiterator_t;

/********************************************************************************/

clinklist_t *
clistInit (void);

int
clistInsert (clinklist_t *, void *);

int
clistAttach (clinklist_t *, void *);

int
clistPush (clinklist_t *, void *);

int
clistPop (clinklist_t *, void **);     

int
clistReverse (clinklist_t *);

void
clistPrint (clinklist_t *);

int
clistSize (clinklist_t *);

int
clistEmpty (clinklist_t *);

int
clistGetElement(clinklist_t *, int, void **);

int
clistGetFirstElement (clinklist_t *, void **);

int
clistDestroy (clinklist_t *);

clistiterator_t *
clistIteratorInit (clinklist_t *);

int
clistIteratorSetFirst (clistiterator_t *);

void *
clistIteratorGetCurrent (clistiterator_t *);

int
clistIteratorSetNext (clistiterator_t *);

void *
clistIteratorGetNext (clistiterator_t *);

int
clistIteratorAssign (clistiterator_t *, clistiterator_t *);

int
clistIteratorDestroy (clistiterator_t *);

int
clistIteratorReset (clistiterator_t *);

#endif
