#!/bin/perl
#$Id$
#$Source$
#
# A. Shaikh
#
#   Pick which data files to run rsgraph.pl
#
#


$topdir = "/opt/users/ashaikh/Research/routesim";
$scriptdir = "$topdir/scripts";

$rsgraph = "$scriptdir/rsgraph.pl";

$filesuffix = "dat";
@dirs = ();
@datfiles = ();
@graphs = ();
$numfiles = 0;
$all = 0;
$specfiles = 0;
##########################################################################################
&getDirs;
if ($all == 1) {
    &graphAll;
}
elsif ($specfiles == 1) {
    &graphSpecFiles;
}
else {
    &askFiles;    
}

&runGraph;


##########################################################################################
sub getDirs {
    my ($dir, $i);

    if ($ARGV[0] eq "-all") {
	$all = 1;
	foreach $i (1 .. $#ARGV) {
	    $dirs[$i-1] = $ARGV[$i];
	}
    }
    elsif ($ARGV[0] eq "-f") {
	$dirs[0] = ".";
	$specfiles = 1;
	foreach $i (1 .. $#ARGV) {
	    $datfiles[$i-1] = $ARGV[$i];
	}
    }
    else {
	@dirs = @ARGV;
    }
    foreach $dir (@dirs) {
	if (! -d $dir) {
	    die "$dir is not a directory";
	}
    }
}
##########################################################################################    
sub askFiles {
    local ($dir, $file, $ans, $leg, $index);
    
    foreach $dir (@dirs) {
	opendir (DATADIR, "$dir") || die "Can't open $dir\n";
	print "Looking in $dir ...\n";
	foreach $file (sort readdir(DATADIR)) {
	    if ($file =~ /\.$filesuffix/) {	    
		print "Add file $file? [y/n] ";
		$ans = <STDIN>;
		chop ($ans);
		$ans =~ tr/A-Z/a-z/;
		if ($ans eq "y") {
		    print "Legend string? ";
		    $leg = <STDIN>;
		    chop ($leg);
		    $graphs[$numfiles]->{filename} = "$dir/$file";
		    $graphs[$numfiles++]->{legend} = $leg;
		}
	    }
	}
	closedir(DATADIR);
    }
}
##########################################################################################
sub graphSpecFiles {
    my ($dir, $file, $ans, $leg, $defleg, $index);

    foreach $dir (@dirs) {
	opendir (DATADIR, "$dir") || die "Can't open $dir\n";
	print "Looking in $dir ...\n";
	foreach $file (@datfiles) {
	    print "Add file $file? [y/n] ";
	    $ans = <STDIN>;
	    chop ($ans);
	    $ans =~ tr/A-Z/a-z/;
	    if ($ans eq "y") {
		if ($file =~ /\.$filesuffix/) {
		    $_ = $file;
		    /rs-(.+)\.$filesuffix/;
		    $defleg = $1;
		}
		print "Legend string [$defleg] ? ";
		$leg = <STDIN>;
		chop ($leg);		
		if ($leg eq "") {
		    $leg = $defleg;
		}
		$graphs[$numfiles]->{filename} = "$dir/$file";
		$graphs[$numfiles++]->{legend} = $leg;
	    }
	}
	closedir(DATADIR);
    }
}

##########################################################################################
sub graphAll {
    my ($dir, $leg, $file);

    foreach $dir (@dirs) {
	opendir (DATADIR, "$dir") || die "Can't open $dir\n";
	print "Looking in $dir ...\n";
	foreach $file (sort readdir(DATADIR)) {
	    if ($file =~ /\.$filesuffix/) {
		$_ = $file;
		/rs-(.+)\.$filesuffix/;
		    #/([a-z]+_[0-9]+\.?[0-9]*)/;
		$leg = $1;
		$graphs[$numfiles]->{filename} = "$dir/$file";
		$graphs[$numfiles++]->{legend} = $leg;
	    }
	}
	closedir(DATADIR);
    }
}


sub runGraph {

    local ($cmd);
    $cmd = "$rsgraph ";
    $suffix = " &";
    for ($i = 0; $i < $numfiles; $i++) {
	$cmd = $cmd . "$graphs[$i]->{filename} \"$graphs[$i]->{legend}\" ";
    }
#    print $cmd . "\n";
    system ("$cmd");
}
	
	
