#!/bin/perl
#$Id$
#$Source$
#
# A. Shaikh
#
# A simple script to run the routesim simulator program many times to generate
# experiment data.
#
#

$opts = "";
$routesimdir = "/export/home/shaikh/routesim";

$conffile = "rs.conf";

open SYS, "uname -s |";
while (<SYS>) {
    chop;
    $sys = $_;
}

$hostname = $ENV{HOST};

$exefile = "$routesimdir/bin/$sys/routesim";

#traffic variables
%simvars = ();
# for subnet-to-subnet TCP flows
$avglen = 95.413;
$len99 = 1476.46;
    
#topology variables
$load = 0.80;
$linkcapacity = 3.270;
$avghopcount = 2.814;
$numnodes = 100;
$numlinks = 568;
##########################################################################################
## &readCmdRuns;
$loadconst = &calcLoadConst($load);
&checkFiles;
&initVars;
&runSim;
&mail_report;

##########################################################################################

sub initVars
{
    my ($i, $var);
# simulation variables
#    $simvars{periods} = [5, 10, 20, 30, 40, 60, 70, 80, 90, 100, 120, 130, 150, 170, 180, 200, 220, 250, 280, 300, 360];
#    $simvars{periods} = [5, 10, 20];    
#    $simvars{periods} = [30, 40, 60];
#    $simvars{periods} = [70, 80, 90];
#    $simvars{periods} = [100, 120, 130];
#    $simvars{periods} = [150, 170, 180];

    $simvars{bandwidth} = [.03];
    foreach  $i (0 .. $#{ $simvars{bandwidth} } ) {
	$simvars{arrivals}->[$i] = $avglen * $simvars{bandwidth}->[$i] / $loadconst;
    }    

}


sub runSim
{

    local ($b, $band, $arr, $suffix, $outfile, $pd, $cmd, $mincalls, $mult, $time);

    foreach $pd (@{$simvars{periods}}) {
	foreach $b (0 .. $#{ $simvars{bandwidth} }) {
	    $band = $simvars{bandwidth}->[$b];
	    $arr = $simvars{arrivals}->[$b];	    
	    $suffix = "pd\_$pd-bw\_$band";
	    $outfile = "rs-$suffix";
#	    $time = 20.0 * $len99;
	    open (OUTFILE, ">>$outfile") or die "ERROR: Could not open $outfile for appending\n";	    
	    $cmd = "$exefile -conf $conffile -bandwidth $band -arrscale $arr -refresh $pd  >>$outfile";
#	    print "$cmd" . "\n";
	    system("$cmd");
	    close OUTFILE;
	}
    }
}


sub checkFiles
{
    local ($newfile);

    if ((! -e "$exefile") || (! -x "$exefile")) {
	die "ERROR: $exefile not found or not executable\n";
    }

}

sub mail_report
{
    $sendmail = "/usr/lib/sendmail";
    $mail_user = "ashaikh\@eecs.umich.edu";
	
    open (SENDMAIL,"|$sendmail $mail_user") || die "Couldn't open mail";
    print SENDMAIL "To: $mail_user\n";
    print SENDMAIL "From: $exefile  <$hostname>\n";
    print SENDMAIL "Subject: runrgperiods.pl complete on $hostname\n";
    print SENDMAIL "\n";
    
    close(SENDMAIL);
}

sub calcLoadConst {
 # arguments: load
    my ($avghops, $N, $L);

    $avghops = $avghopcount;
    $N = $numnodes;
    $L = $numlinks;
    $loadconst = $_[0] / $N / $avghops * $L * $linkcapacity;
    # = 1/I * l * bw
    $loadconst;
}   


