/* $Id: rslog.c,v 1.2 1997/10/15 19:27:40 ashaikh Exp $ */


static const char rcsid[] = "$Id: rslog.c,v 1.2 1997/10/15 19:27:40 ashaikh Exp $";

#include "rslog.h"
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>

#define LOGFILE "routesim.log"

typedef struct _logrecord {
  int	logfd;
  FILE	*logfile;
  int	lastpos;
} logrecord;


static logrecord    logs[MAX_NUM_LOGS];
static int	    logindex = 0;

int
rsInitLog (const char *filename)
{
  int	index;
  
  index = logindex++;
  logs[index].logfd = open (filename, O_WRONLY|O_CREAT|O_TRUNC, 0640);
  if (logs[index].logfd < 0){
    perror ("Error opening fd");
    return (-1);
  }
  logs[index].logfile = fdopen (logs[index].logfd, "w");
  if (logs[index].logfile == NULL) {
    fprintf (stderr, "Error opening %s: %s\n", LOGFILE, strerror(errno));
    return (-1);
  }
  logs[index].lastpos = lseek(logs[index].logfd, (off_t) 0x0, SEEK_SET);

  return (index);
}

void
rsWriteLog (int index, char *mesg, int rewnd)
{
  if (rewnd) {
    lseek (logs[index].logfd, (off_t) logs[index].lastpos, SEEK_SET);
    write (logs[index].logfd, mesg, (strlen(mesg)));
  }
  else {
    write (logs[index].logfd, mesg, (strlen(mesg)));
    logs[index].lastpos = lseek(logs[index].logfd, (off_t) 0x0, SEEK_CUR);    
  }
}

void
rsCloseLog (int index)
{
  close(logs[index].logfd);
}

