/*$Id: rsmail.c,v 1.1 1998/09/14 15:23:12 ashaikh Exp $*/

#include "rsmail.h"
#include "rstrace.h"
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <errno.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/types.h>



char	    mailrecpt[MAX_ADDRESS_LEN] = "\0";

/********************************************************************************/
int
sendRSNotification (rsnotification_t noticetype)
{

  char		*mailcmd;
  const char	*from = "From: routesim\n";
  char		*to, *subject;
  char		mesg[255], timebuf[26], host[128];
  FILE		*mailer;
  time_t	currenttime;


  /* create mail command */
  mailcmd = (char *) malloc (strlen(mailrecpt) + strlen(DEFAULT_MAIL_CMD) + 2);
  sprintf (mailcmd, "%s %s", DEFAULT_MAIL_CMD, mailrecpt);

  /* open a pipe to the mailer */
  mailer =  popen (mailcmd, "w");
  if (mailer == (FILE *) 0){
    RS_PRINT_ERROR1 ("sendNotification: Error opening %s\n", mailcmd);
    return (-1);
  }

  /* fill in To: field */
  to = (char *) malloc (strlen(mailrecpt) + 6);
  sprintf (to, "To: %s\n", mailrecpt);

  /* get the current time */
  currenttime = time((time_t *) 0);
  if (currenttime == (time_t) -1) {
    RS_PRINT_ERROR1 ("sendNotification: Couldn't read local time: %s\n", strerror(errno));
    return (-1);
  }
  strcpy (timebuf, ctime (&currenttime));

  /* get the local host name */
  strcpy (host, getenv ("HOST"));

  switch (noticetype) {
  case RS_COMPLETE_NOTICE:
    subject = (char *) malloc (strlen("Subject: Routesim complete\n") + 1);
    strcpy (subject, "Subject: Routesim complete\n");
    break;
  case RS_ERROR_NOTICE:
    subject = (char *) malloc (strlen("Subject: Routesim error!\n") + 1);
    strcpy (subject, "Subject: Routesim error!\n");
    break;
  default:
    RS_PRINT_ERROR ("sendNotification: Unknown notice type\n");
    return (-1);
  }

  /* construct body */
  strcpy (mesg, "Completion time: ");
  strcat (mesg, timebuf);
  strcat (mesg, "\nMachine: ");
  strcat (mesg, host);

  /* write out the message */
  fprintf (mailer, to);
  fprintf (mailer, from);
  fprintf (mailer, subject);
  fprintf (mailer, mesg);
  fprintf (mailer, ".\n");

  if (pclose (mailer) < 0) {
    RS_PRINT_ERROR ("sendNotification:  Pipe close returned error\n");
    return (-1);
  }

  free (mailcmd);
  free (to);
  free (subject);

  return (0);
}
  
/********************************************************************************/
int
sendRSNotice (void)
{

  if (strlen(mailrecpt) == 0)
    return (0);
  else
    return (1);
}
