#include<stdio.h>

typedef struct _call_t {
  int source;
  int dest;
  int routeindex;
  int **allroutes;
} call_t;

typedef struct _linkmetric_t {
  double  current;
} linkmetric_t;

/*  link structure */
typedef struct _link_t {
  int		id;		/* link identifier */
  int		from;		/* node id of "from" node */
  int		to;		/* node it of "to" node */
  double	capacity;	/* max available bandwidth */
  linkmetric_t	availbw;	/* current available bandwidth */
} link_t;


typedef struct {
  link_t	    ***links;
  int		    numnodes;
  int		    numlinks;
  rsstat_t	    *stats;		/* statistics package for the network */
} topology_t;


int hsfExec(call_t *newcall, double time, double bw, topology_t *network, int *result)
{
  link_t *currlink;
  
  int **allroutes;
  int kindex, nodeindex;
  int flag = 0;
  int nexthopindex, currindex;
  

  allroutes = newcall->allroutes;
  kindex = 0; nodeindex = 0;
  newcall->routeindex = -1;

  if(newcall->source == newcall->dest) {
    newcall->routeindex = 0;
    *result = ROUTE_CALC_SUCCESS;
    return (0);
  }

  /* Adding code for network cost
   * Ganga - 03/30/2000
   */

  for(kindex = 0; allroutes[kindex][0] != -1; kindex++) {
    for(nodeindex = 0; allroutes[kindex][nodeindex] !=-1; nodeindex++) {
      network->stats->nodesvisited++;
    }
  }


  
  for(kindex = 0; allroutes[kindex][0] != -1; kindex++) {
    nodeindex = 0;
    flag = 0;
    for(nodeindex = 0; allroutes[kindex][nodeindex] !=-1; nodeindex++) {
      currindex = allroutes[kindex][nodeindex];
      nexthopindex = allroutes[kindex][nodeindex+1];
      if(nexthopindex == -1) 
	break;      
      currlink = network->links[currindex][nexthopindex];
      
      if ((currlink->availbw.current) < bw) {
	flag = 1;
	break;
      }
    }
    if (!flag) {
      newcall->routeindex = kindex;
      *result = ROUTE_CALC_SUCCESS;
      return 0;
    }
  }  
  
  *result = ROUTE_CALC_FAIL;
  newcall->routeindex = -1;
  return 0;
}
