/* $Id: sptgeneric.h,v 1.2 1999/05/03 16:27:15 ashaikh Exp $ */

#ifndef _sptgeneric_h_
#define _sptgeneric_h_

#include "topology.h"
#include "clinklist.h"
#include "priorityQ.h"
#include <limits.h>

#define	    SPTINF  (INT_MAX-1)

typedef struct {
  int		    source;	    /* source that this tree belongs to */
  topology_t	    *network;	    /* network that the tree corresponds to */
  int		    valid;	    /* is this a valid tree */
  clinklist_t	    **parents;	    /* final shortest path tree structure */
  clistiterator_t   **headptrs,
		    **walkptrs;	    /* iterators for parent tree lists */
  double	    comptime;	    /* time this tree was computed */
  int		    computations;   /* number of times this tree was recomputed */
} spt_t;

typedef struct {
  int		    parent;
} sptparent_t;
/********************************************************************************/
int
sptInit (spt_t **, topology_t *);
int
sptDestroy (spt_t *);
void
sptReset (spt_t *);
void
sptCleanup  (pq_t *);

int
sptHopMultiExec (spt_t *, int);
int
calcSimpleSPT (topology_t *, int, int *);

int
addParent (spt_t *, int, int);
int
clearParents (spt_t *, int);

int
sptIsNodeConnected (spt_t *, int);

int
sptMultiPathExtractInit (spt_t *);
int
sptExtractFirstPath (spt_t *, int, int, int **);

int
sptGetPathLen (spt_t *, int, int);
int
sptGetSpecPathLen (int, int, int *);

void
sptPrintPathLens (spt_t *, int);
void
sptPrintTree (spt_t *);


#endif
